# Define the kmod package name here.
%define kmod_name drbd83
%define short_name drbd

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 2.6.18-8.el5}

# Disable the building of the debug package(s).
%define debug_package %{nil}

Name:    %{kmod_name}-kmod
Version: 8.3.7
Release: 1.sl5
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s) for Distributed Redundant Block Device.
URL:     http://www.drbd.org/

BuildRequires: redhat-rpm-config gcc
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-build-%(%{__id_u} -n)
ExclusiveArch: i686 x86_64
Provides: kernel-module-drbd
Provides: drbd-kmod
Provides: drbd-kernel-module-%{version}
Provides: drbd-kmdl-%{version}

# Sources.
Source0:  %{kmod_name}-%{version}.tar.gz
Source10: kmodtool-%{kmod_name}-sl5.sh

# Define the variants for each architecture.
%define basevar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch i686 x86_64
%define xenvar xen
%endif

# If kvariants isn't defined on the rpmbuild line, build all variants for this architecture.
%{!?kvariants: %define kvariants %{?basevar} %{?xenvar} %{?paevar}}

# Magic hidden here.
%define kmodtool sh %{SOURCE10}
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kversion} %{kvariants} 2>/dev/null)}

# Define the filter.
%define __find_requires sh %{_builddir}/%{buildsubdir}/filter-requires.sh

%description
DRBD is a block device which is designed to build high availability
clusters. This is done by mirroring a whole block device via (a
dedicated) network. You could see it as a network raid-1.

This package contains the drbd %{version} kernel modules for the Linux kernel.

%prep
%setup -c -T -a 0

%define __find_requires sh %{_builddir}/%{buildsubdir}/filter-requires.sh
echo "/usr/lib/rpm/redhat/find-requires | sed -e '/^ksym.*/d'" >filter-requires.sh

pushd %{short_name}-%{version}
%configure \
    --with-km \
    --without-bashcompletion \
    --without-heartbeat \
    --without-pacemaker \
    --without-rgmanager \
    --without-utils
popd
for kvariant in %{kvariants} ; do
    %{__cp} -a %{short_name}-%{version} _kmod_build_$kvariant
    %{__cat} <<-EOF >_kmod_build_$kvariant/drbd/%{kmod_name}.conf
        override %{kmod_name} * weak-updates/%{kmod_name}
EOF
done

%build
for kvariant in %{kvariants} ; do
    ksrc="%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}"
    %{__make} -C _kmod_build_$kvariant KDIR="${ksrc}" module
done

%install
%{__rm} -rf %{buildroot}

export INSTALL_MOD_PATH="%{buildroot}"
export INSTALL_MOD_DIR="extra/%{kmod_name}"
for kvariant in %{kvariants} ; do
    ksrc="%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}-%{_target_cpu}"
    pushd _kmod_build_$kvariant/drbd
    %{__make} -C "${ksrc}" modules_install M="$PWD"
    %{__install} -Dp -m0644 %{kmod_name}.conf %{buildroot}/etc/depmod.d/kmod-%{kmod_name}.conf
    popd
done
# Strip the module(s).
find %{buildroot} -type f -name \*.ko -exec strip --strip-debug \{\} \;

%clean
%{__rm} -rf %{buildroot}

%changelog
* Wed May 23 2012 Pat Riehecky <riehecky@fnal.gov> - 8.3.7-1.sl5
- Adapted package from ELREPO for SL/SLF 5
  More up to date packages are avalible at elrepo.org
